#include "global.h"


double allBytes[5] = { 0, 0, 0, 0, 0 }, allSeconds[5] = { 0, 0, 0, 0, 0 }, ccBytes = 0,
       allmBytes[5] = { 0, 0, 0, 0, 0 }, allmSeconds[5] = { 0, 0, 0, 0, 0 };
int allCount[5] = { 0, 0, 0, 0, 0 }, ccCount = 0;
struct eCodes ec[602];


char GlobalFilterS(char *iEntry, char **iList, char iMode, short int iCount);
char GlobalFilterS(char *iEntry, char **iList, char iMode, short int iCount) {
    short int i;

    if (iMode < 2) {
	for (i = 0; i < iCount; i++)
	    if (strstr(iEntry, iList[i]) != NULL) return iMode%2;
    } else {
	if (bsearch(&iEntry, iList, (size_t)iCount, sizeof(char *), (int (*)(const void *, const void *))SAstrcmp) != NULL)
	    return iMode%2;
    }

    return !(iMode%2);
}


short int ComputeIndics(short int tcode, char tmethod, char *turl, char *tstat);
short int ComputeIndics(short int tcode, char tmethod, char *turl, char *tstat) {
    short int tIndic = 0;
    int i;
    char *t;


    /* saf, paf, sdn, pdn */
    switch (LogFormats[cfg.LogFormat].Class) {
        case PROXY:
        case WWW:
    	    switch (tcode) {
		case 401: 
			if (cfg.TTR[SAF]) SAsetbit(tIndic, SAF);
			break;
		case 403:
			if (cfg.TTR[PDN] && *tstat == 1) SAsetbit(tIndic, PDN);
			else if (cfg.TTR[SDN]) SAsetbit(tIndic, SDN);
			break;
		case 407:
			if (cfg.TTR[PAF]) SAsetbit(tIndic, PAF);
		default:
			if (*tstat == 1) *tstat = 3; /* PER: replace not proxy denied by other local */
			break;
	    }
	    break;
	    
	case MAIL:
	    switch (tcode) {
		case 451:
			if (cfg.TTR[SDN]) SAsetbit(tIndic, SDN);
			break;
		default:	
			if (cfg.TTR[PDN] && *tstat == 1) SAsetbit(tIndic, PDN);
			break;
	    }
	    break;
	}
	
    /* cct, pst */
    switch(tmethod) {
        case 'C': if (cfg.TTR[CCT]) SAsetbit(tIndic, CCT); break;
        case 'P': if (cfg.TTR[PST]) SAsetbit(tIndic, PST); break;
    }
	
    /* dld */
    if (cfg.TTR[DLD] && tmethod != 'C')
        for (i = 0; i < icfg.dldCount; i++) {
    	    t = &turl[strlen(turl) - strlen(icfg.Downloads[i])];
		
	    if (strcmp(t, icfg.Downloads[i]) == 0) {
	        SAsetbit(tIndic, DLD);
	        break;
	    }
	}

    return tIndic;
}


#define F_COLLECTLOG "CollectLog"
void CollectLog(FILE *Log, time_t *rsdate, time_t *redate) {
    char tip[MAXIP], tname[MAXUSERNAME], tmethod, turl[MAXLEN], tstat;
    double tBytes, tSeconds;
    short int tcode, tIndic;
    struct SAentry *res = NULL;
    struct SAuconv ukey, *ures;
    struct hostent *hp;
    struct in_addr resip;
    char *t = NULL, *iname;
    time_t ttime, mindate = 0L;
    int i;
    
    
    while(READ_RECORD(Log, &ttime, &tSeconds, tip, &tcode, &tBytes, &tmethod, turl, tname, &tstat)) {
	/* Check if record in specified date range (according to linearity of log */
	if (LogFormats[cfg.LogFormat].isLinear) { if (ttime > icfg.EDate) break; }
	else if (ttime < icfg.SDate || ttime > icfg.EDate) continue;
	
        /* Internal name resolution and fix */
	if (!cfg.INameUser || tname[0] == '-') iname = tip;
	else {
	    iname = tname;
	    /* Remove incorrect symbols (some for security reasons) */
	    for (t = iname; t[0] != '\0'; t++) if (t[0] == '\\' || t[0] == '%' || t[0] == '$' || t[0] == '/' || t[0] == '`' || t[0] == '|' || t[0] == '&') t[0] = '_';
	}

	/* Apply global filter */
	if (icfg.GF) {
	    if (gfcfg.inameCount) if (GlobalFilterS(iname, gfcfg.inames, gfcfg.inameMode, gfcfg.inameCount)) continue;
	    if (gfcfg.urlCount) if (GlobalFilterS(turl, gfcfg.urls, gfcfg.urlMode, gfcfg.urlCount)) continue;
	}
	
        /* Search for internal name in Users only if Users is not empty
	   otherwise fill start date for period computing */
	if (icfg.ueCount) res = SAentryByName(iname);
	else mindate = ttime;
	
	/* If internal name not found in Users or Users is empty (i.e. 1st iteration) */
	if (res == NULL) {
	    Users = (struct SAentry *)SArealloc((void *)Users, sizeof(struct SAentry) * (icfg.ueCount + 1L));
	    res = &Users[icfg.ueCount];
	    /* Fill user unsorted file name u_USERNAME.uns */
	    sprintf(res->fname, TEMPL_U_UNS, cfg.TempDir, iname);
	    res->file = SAfopenI("w", res->fname);
	    res->ip = SAstrcpy(tip);
	    /* Clear (i.e. set to 0) starting from vname up to the end of structure */
	    memset((void *)&res->vname, 0, sizeof(res->vname) + sizeof(res->Bytes) + sizeof(res->count) + sizeof(res->TTcount));
	    
	    /* res->name is saved internal name */
	    if (iname != tip) res->name = SAstrcpy(iname);
	    else {
		/* If we use IP instead of name and should resolve it then try to fill vuser */
		if (cfg.ResolveIP && inet_pton(AF_INET, iname, &resip) != 0) 
		    if ((hp = gethostbyaddr((char *)&resip.s_addr, sizeof(in_addr_t), AF_INET)) != NULL) 
			res->vname = SAstrcpy(hp->h_name);
		res->name = res->ip;
	    }
	    
	    /* If UserTab have entries and we not resolved IP before, then fill vname according it */
	    if (icfg.utCount && !res->vname) {
		ukey.iname = iname;
		ures = (struct SAuconv *)bsearch(&ukey, icfg.Usertab, (size_t)icfg.utCount, sizeof(struct SAuconv), (int (*)(const void *, const void *))compSAuconv);
		if (ures != NULL) res->vname = ures->ename;
	    }
	    
	    /* If we still not filled vname, then fill it as name */
	    if (!res->vname) res->vname = res->name;

	    icfg.ueCount++;
	    	    
	    qsort(Users, (size_t)icfg.ueCount, sizeof(struct SAentry), (int (*)(const void *, const void *))compSAentry);

	    /* After sorting we should recover pointer (iname points to tname, so it's not damaged by qsort) */
	    res = SAentryByName(iname);
	}
	
	tIndic = ComputeIndics(tcode, tmethod, turl, &tstat);
	
	/* TT_UNS: write to file & user TT-stats */
	for (i = 0; i < TTNUMBER; i++)
	    if (SAgetbit(tIndic, i)) {
		/* write only if limit allows it */
		if (!cfg.ttUserLimit[i] || res->TTcount[i] < cfg.ttUserLimit[i]) {
		    fprintf(TT[i].file, "%s %ld %s %hd\n", iname, ttime, turl, tIndic);
		    TT[i].count++;
		}
		res->TTcount[i]++;
	    }
	
	/* PER: collect */
	if (cfg.PER) {
	    if (tstat) {
		i = (int)tstat;
		allBytes[i] += tBytes;
		allSeconds[i] += tSeconds;
	        allCount[i]++;
		
		if (tBytes > allmBytes[i]) allmBytes[i] = tBytes;
		if (tSeconds > allmSeconds[i]) allmSeconds[i] = tSeconds;
	    } else {
		if (tBytes > allmBytes[4]) allmBytes[4] = tBytes;
		if (tSeconds > allmSeconds[4]) allmSeconds[4] = tSeconds;
	    }
	    
	    ec[tcode].Bytes += tBytes;
	    ec[tcode].Seconds += tSeconds;
	    ec[tcode].Count++;
	}
	
	/* Compute user stats and write to user file */
	if (cfg.FullTraffic || !tstat) {
	    /* Shorten URL (we jump over "http://" or "ftp://" here) */
	    if (!cfg.FullURL && tmethod != 'C') {
		for (t = &turl[7]; t[0] != '\0' && t[0] != '/'; t++);
		t[0] = '\0';
	    }
	
	    /* Compute user stats */
	    res->Bytes += tBytes;
	    res->count++;
	    
	    /* Compute total stats for TopUser report */
	    ccBytes += tBytes;
	    ccCount++;
	    
	    fprintf(res->file, "%.0f %ld %s %hd %c\n", tBytes, ttime, turl, tIndic, tmethod);
	}
	
	/* Compute total stats */
	allBytes[0] += tBytes;
	allSeconds[0] += tSeconds;
	allCount[0]++;
    }

    /* Exit if no records found */
    if (!icfg.ueCount) SAexit(F_COLLECTLOG, "No records found");

    /* Close log file */
    SAfclose(Log, cfg.Log);
    
    /* Fill real start/end dates */
    *rsdate = mindate;
    *redate = ttime;
}


#define F_SEEKLOG "SeekLog"
char SeekLog(FILE *Log, time_t sdate) {
    SAOFF_T rseek = 0L, sseek = 0L, eseek = 0L, osseek = 0L, oeseek = 0L;
    time_t ttime;


    /* Seek in linear log */
    if (LogFormats[cfg.LogFormat].isLinear) {
	/* Fast check for first record date */
	if (!READ_DT(Log, &ttime)) SAexit(F_SEEKLOG, "Can't read log");
	if (ttime >= sdate) {
	    rewind(Log);
	    return 0;
	}

	/* Fast check for last record date */
	SAfseek(Log, 0L, SEEK_END, cfg.Log);
	/* If log is not short we rewind it to last records */
	if (SAftell(Log) >= (SAOFF_T)LogFormats[cfg.LogFormat].MaxRecordLength) SAfseek(Log, -((SAOFF_T)LogFormats[cfg.LogFormat].MaxRecordLength), SEEK_END, cfg.Log);
	else rewind(Log);
	READ_ALIGN(Log);
	while(READ_DT(Log, &ttime));
	if (ttime < sdate) return 1;

	/* Set up EOF position */
	eseek = SAftell(Log);
	
	/* Fast (?) binary search */
	for(;;) {
	    /* Seek to middle of range */
	    SAfseek(Log, sseek + (eseek - sseek) / 2L, SEEK_SET, cfg.Log);
	    
	    READ_ALIGN(Log);
	    /* Save real position */
	    rseek = SAftell(Log);

	    /* Select new range */
	    READ_DT(Log, &ttime);
#if DEBUG>=1
	    SAdebug(F_SEEKLOG, "Range %ld <-> %ld, %ld %s %ld position=%ld", sseek, eseek, ttime, (ttime>=sdate) ? ">=" : "< ", sdate, rseek);
#endif
	    if (ttime >= sdate) eseek = rseek;
	    else sseek = rseek;
	    
	    /* If search was stabilized */
	    if (sseek == osseek && eseek == oeseek) {
#if DEBUG>=1
		SAdebug(F_SEEKLOG, "Final range %ld <-> %ld, start position=%ld", sseek, eseek, rseek);
#endif
		/* Final seek to requested date position */
		SAfseek(Log, rseek, SEEK_SET, cfg.Log);
		break;
	    } else {
		osseek = sseek;
		oeseek = eseek;
	    }
	}
    } else SAwarning(F_SEEKLOG, "Non-linear log format detected, can't seek for fast data processing");
    
    return 0;
}


#define F_SHOWLOG "ShowLog"
void ShowLog(FILE *Log) {
    time_t ttime, mindate = SAMAXTIMET, maxdate = 0L;


    if (LogFormats[cfg.LogFormat].isLinear) {
	/* Read first record date */
	if (!READ_DT(Log, &ttime)) SAexit(F_SHOWLOG, "Can't read log");
	mindate = ttime;
	
	/* Read last record date */
	SAfseek(Log, 0L, SEEK_END, cfg.Log);
	/* If log is not short we rewind it to prelast records */
	if (SAftell(Log) >= (SAOFF_T)LogFormats[cfg.LogFormat].MaxRecordLength) SAfseek(Log, -((SAOFF_T)LogFormats[cfg.LogFormat].MaxRecordLength), SEEK_END, cfg.Log);
	else rewind(Log);
	READ_ALIGN(Log);
	while(READ_DT(Log, &ttime));
	maxdate = ttime;
    } else 
	while(READ_DT(Log, &ttime)) {
	        if (ttime < mindate) mindate = ttime;
		if (ttime > maxdate) maxdate = ttime;
	}
    
    /* Seek to end for file size detection */
    SAfseek(Log, 0L, SEEK_END, cfg.Log);
    
    SAshow("Log file information:\n\
File name:\t\t%s\n\
File size:\t\t%'.0f\n\
Start date and time:\t%s\n\
",
    cfg.Log, 1.0 * SAftell(Log), GetDT(mindate, "%x %X"));
    /* Because GetDT is not volatile */
    SAshow("End date and time:\t%s\n", GetDT(maxdate, "%x %X"));
}


#define F_CROPLOG "CropLog"
void CropLog(FILE *Log) {
    time_t ttime;
    FILE *tLog;
    char *tbuf, tfname[MAXFILENAME];
    
    sprintf(tfname, "%s.new", cfg.Log);
    
    tLog = SAfopenI("w", tfname);
    
    tbuf = (char *)SAmalloc((size_t)LogFormats[cfg.LogFormat].MaxRecordLength);

    while (READ_FULLDT(Log, &ttime, tbuf)) {
	/* Check if record in specified date range (according to linearity of log */
	if (LogFormats[cfg.LogFormat].isLinear) { if (ttime > icfg.EDate) break; }
	else if (ttime < icfg.SDate || ttime > icfg.EDate) continue;
	
	fputs(tbuf, tLog);
    }

    free(tbuf);
    SAfclose(tLog, "new");
    SAfcloseU(Log, cfg.Log);
    if (rename(tfname, cfg.Log)) SAexit(F_CROPLOG, "Can't rename %s to %s. %s", tfname, cfg.Log, strerror(errno));
}


#define F_INITLOG "InitLog"
FILE *InitLog(void) {
    FILE *retval;
    short int i, j, tcode, checkval;
    time_t ttime;
    double tSeconds, tBytes;
    char tip[MAXIP], tname[MAXUSERNAME], tmethod, turl[MAXLEN], tstat;
    

    retval = SAfopenI("r", cfg.Log);

    /* Start autodetection of log format if it's not specified */
    if (cfg.LogFormat == -1)
	for (i = 0; (size_t)i < sizeof(LogFormats)/sizeof(struct LogFormat); i++) {
	    READ_RECORDI = LogFormats[i].ReadRecordI;
	    READ_RECORD = LogFormats[i].ReadRecord;


#if DEBUG>=1
	    SAdebug(F_INITLOG, "Checking for %s", LogFormats[i].name);
#endif
	
	    /* Try to read cfg.AutoRecords number of records using log format read function */
	    for (checkval = j = 0; j < cfg.AutoRecords; j++) checkval += READ_RECORD(retval, &ttime, &tSeconds, tip, &tcode, &tBytes, &tmethod, turl, tname, &tstat);

	    /* Rewind to start of log for next try or processing */
	    rewind(retval);

	    if (checkval == cfg.AutoRecords) {
#if DEBUG>=1
		SAdebug(F_INITLOG, "Detected %s with %s records order", LogFormats[i].name, LogFormats[i].isLinear ? "linear" : "random");
#endif
		cfg.LogFormat = i;
		break;
	    } 
#if DEBUG>=1
	    else SAdebug(F_INITLOG, "NOT %s (%hd/%hd readed)", LogFormats[i].name, checkval, cfg.AutoRecords);
#endif
	}
    
    if (cfg.LogFormat == -1) SAexit(F_INITLOG, "Log format autodetection failed");

    /* Clear mail records buffers */
    if (LogFormats[cfg.LogFormat].Class == MAIL) DelAllMR();
    
    /* Set READ_RECORD for manually specified log format (others - for all) */
    READ_RECORDI = LogFormats[cfg.LogFormat].ReadRecordI;
    READ_RECORD = LogFormats[cfg.LogFormat].ReadRecord;
    READ_DT = LogFormats[cfg.LogFormat].ReadDT;
    READ_FULLDT = LogFormats[cfg.LogFormat].ReadFullDT;
    READ_ALIGN = LogFormats[cfg.LogFormat].ReadAlign;
    
    /* Disable unsupported by log format TT-reports */
    for (j = 0; j < 6; j++) if (cfg.TTR[j] == 1 && LogFormats[cfg.LogFormat].Capabilities[j] == 0) cfg.TTR[j] = 0;
    
    /* Disable TSR if unsupported by log format */
    if (LogFormats[cfg.LogFormat].Capabilities[7] == 0) cfg.TSR = 0;
    
    /* Seek to start date only if SDate is specified */
    if (icfg.SDate) if (SeekLog(retval, icfg.SDate)) SAexit(F_INITLOG, "No records found");
    
    return retval;
}
